﻿

@using Jumbula.Common.Helper
@model DisplayCartViewModel

@{
    var isNotValid = Request.QueryString["isNotValid"] != null ? Request.QueryString["isNotValid"].ToString() : string.Empty;
    var message = Request.QueryString["message"] != null ? Request.QueryString["message"].ToString() : string.Empty;
    var IsEmpty = Request.QueryString["IsEmpty"] != null ? Request.QueryString["IsEmpty"].ToString() : string.Empty;
    var isPaidOrCanceled = Request.QueryString["isPaidOrCanceled"] != null ? Request.QueryString["isPaidOrCanceled"].ToString() : string.Empty;
}

<script>

    var total = -1;
    var credit = 0;
    var maxamount = '';
    $('#txtCardNumber').on('change', function () {
        $(this).val($(this).val().replace('-', ""))
        $(this).val($(this).val().replace(' ', ""))
        $(this).val($(this).val().trim())
    });

    $(load);

    function load() {
        total = $("#total-price-span").html();
        credit = $("#credit-amount").html();
    };


    if (window != top) {
        top.location.replace(document.location);
    }


    var linkHandler = Plaid.create({

        selectAccount: true,
        env: '@Model.PlaidEnvironment',
        clientName: '@Model.ClientName',
        key: '@Model.PlaidKey',
        product: 'auth',
        onSuccess: function (public_token, metadata) {

            var invoiceId = '@Model.InvoiceId';
            callPaymentAction(public_token, metadata, invoiceId);
        },
        onExit: function () {

            unblockUI();
        },
    });

    function callPaymentAction(public_token, metadata, invoiceId) {
        blockUI();
        $.ajax({
            type: "POST",
            url: '@Url.Action("AchPaymentAsync", "Stripe")' + '?token=' + public_token + '&accountId=' + metadata.account_id + '&invoiceId=' + invoiceId,
            success: function (res) {
                if (res.Status) {
                    window.location = res.Message;
                } else {
                    unblockUI();
                    toastr.error(res.Message);
                }
            },
            error: function (ex) {
                unblockUI();
                toastr.error(ex);
            },
            complete: function () {
            }
        });
    }

    $(document).ready(function(){

        var isPaid='@isPaidOrCanceled';
        if (isPaid=='True') {
            toastr.error("This invoice has already been paid or canceled.");
        }
        $('#txtCardNumber').on('change', function(){
            $(this).val($(this).val().replace(/\s+-/g,""))
            $(this).val($(this).val().replace(' ',""))
        });

        name="PaymentMethod";

        InitRadio('PaymentMethod');
        document.getElementById('OfflinePayment').value = 'false';
        var isNotValid = '@isNotValid';
        var message = '@message';
        var testMode = '@Model.IsTestMode';
		
        var switchCountry =function(country){

            var zipLabel = "ZIP code";

            $.ajax({
                type: "Get",
                url: '/Cart/States?country=' + country,
                success: function (res) {
                    $('#stateContainer').html(res);

                    switch (country) {
                    case 'Canada':
                        {
                            zipLabel = "Postal code";
                        }
                        break;
                    default:
                        {}
                    }

                    $('#zipLabel').html(zipLabel);

                }
            });




        };

        $('#country').change(function(){

            switchCountry($(this).val());
        });



        if (isNotValid != '') {
            if (message != '') {
                var typeMessage=message.substring(0, message.indexOf(':'));

                $('#send-url').prop('disabled', false);
                $("#radio-" + typeMessage).trigger("click");

            }
            else{
                $('#send-url').prop('disabled', false);
                $("#radio-card").trigger("click");
            }

        }

        $("#send-url").click(function (e) {
            e.preventDefault();
            e.stopPropagation();

            if (testMode=='True') {
                eModal.confirm(AlarmInTestMode).then(callback, function () { return false; });
            } else
            {
                callback(
                    {
                        css: {
                            border: 'none',
                            padding: '15px',
                            backgroundColor: '#000',
                            '-webkit-border-radius': '10px',
                            '-moz-border-radius': '10px',
                            opacity: .5,
                            color: '#fff'
                        },
                        message: '<h6>Please wait...<br /> Do not close your browser or click on the back button while we are finalizing the order.</h6>'
                    }
                );
            }
        });

        function callback(){

            if(arguments.length==1){
                blockUI(arguments[0]);
            }
            else
                blockUI();
            $('#send-url').prop("disabled", true);
            document.getElementById("send-url").style.backgroundColor="#9E9E9E";
            var isPaid='@isPaidOrCanceled';
            if (isPaid=='True') {
                toastr.error("This invoice has already been paid or canceled.");
                return;
            }
            var isNotValid = '@isNotValid';
            isNotValid=false;
            if(arguments.length==1){
                blockUI(arguments[0]);
            }
            else
                blockUI();
            var url = '';
            $(window).load(unblockUI);

            if ($('#radio-paypal').attr('chk') == '1') {
                $('#frmCharge').submit();
                return;
            }
            if ($('#radio-Echeck').attr('chk') == '1') {
                $('#send-url').prop('disabled', false);
                document.getElementById("send-url").style.backgroundColor="#e7830d";
                $.ajax({
                    type: "Get",
                    url: '@Url.Action("CheckCartValidation", "Cart")' + '?userId=' + '@Model.UserId',
                    success: function (res) {

                        if (res.Status == false) {
                            var time = new Date().getTime();

                            if (res.Data.length > 0) {

                                toastr.error(res.Data);
                                setTimeout(refresh, 10000);
                            }
                        }
                        else {

                            if (url.length > 0) {

                                window.location = url;
                            }
                            else {
                                linkHandler.open();
                            }
                        }
                    },
                    error: function (ex) {
                        unblockUI();
                        $('#send-url').prop('disabled', false);
                        document.getElementById("send-url").style.backgroundColor="#e7830d";
                        toastr.error(ex);
                    }

                });
                return;
            }
            if ($('#radio-cash').attr('chk') == '1') {

                $('#frmCharge').submit();
                return;
            }
            if ($('#radio-bank').attr('chk') == '1') {

                $('#frmCharge').submit();
                return;
            }
            if ($('#radio-scholarship').attr('chk') == '1') {

                $('#frmCharge').submit();
                return;
            }
            if ($('#radio-express').attr('chk') == '1') {

                $('#frmCharge').submit();
                return;
            }

            if ($('#radio-card').attr('chk') == '1') {

                var number= $('#txtCardNumber').val();
                var str= number.trim().split(' ').join('');
                var newString = str.replace(/[^A-Z0-9]/ig, "");
                $('#txtCardNumber').value=newString;

                if (isNotValid == '' ) {

                    Stripe.setPublishableKey('@Model.PaymentModel.PublishableKey');
                }

                $.ajax({
                    type: "Get",
                    url: '@Url.Action("CheckCartValidation", "Cart")' + '?userId=' + '@Model.UserId',
                    success: function (res) {

                        if (res.Status == false) {

                            window.location = '@Url.Action("Index", "Cart")' + '?userId=' + '@Model.UserId';
                        }

                    },
                    error: function (ex) {
                        unblockUI();
                        $('#send-url').prop('disabled', false);
                        document.getElementById("send-url").style.backgroundColor="#e7830d";
                        toastr.error(ex);
                    }

                });



                // Disable the submit button to prevent repeated clicks. Run the progress bar or loading
                var errormessage = '';
                if (Stripe.card.validateCardNumber($('#txtCardNumber').val()) == false) {
                    errormessage = "The card number is invalid. <br/>";

                }
                if (Stripe.card.validateCVC($('#txtCvc').val()) == false) {
                    errormessage += "The CVC number is invalid.<br/>";
                }
                if ($('#txtCardHolderName').val() == "") {
                    errormessage += "The cardholder name is invalid.<br/>";
                }
                if (($('#address').val()) == "") {
                    errormessage += "The address is invalid.<br/>";
                }
                if (Stripe.card.validateExpiry($('#txtExpiryMonth').val(), $('#txtExpiryYear').val()) == false) {
                    errormessage += "The expiration date is invalid.<br/>";
                }
                if (errormessage != '') {

                    unblockUI();
                    $(".payment-errors").html(errormessage);

                    $('#send-url').prop('disabled', false);
                    document.getElementById("send-url").style.backgroundColor="#e7830d";
                }
                else {

                    var number= $('#txtCardNumber').val();
                    var str= number.trim().split(' ').join('');
                    var newString = str.replace(/[^A-Z0-9]/ig, "");

                    Stripe.card.createToken({
                        number:newString,
                        cvc: $('#txtCvc').val(),
                        exp_month: $('#txtExpiryMonth').val(),
                        exp_year: parseInt($('#txtExpiryYear').val())+2000,
                        name: $('#txtCardHolderName').val(),
                        address_line1: $('#street').val(),
                        //address_line2: $('#address').val(),
                        address_zip: $('#zip').val(),
                        address_city: $('#city').val(),
                        address_state: $("#state option:selected").text(),
                        address_country: $('#country option:selected').text(),

                    }, stripeResponseHandler);

                }

                function stripeResponseHandler(status, response) {
                    // Check Status first

                    if (response.error) {
                        $('.payment-errors').text(response.error.message);
                        $('#send-url').prop('disabled', false);
                        document.getElementById("send-url").style.backgroundColor="#e7830d";
                        $('#hdnCreateTokenResponse').val(JSON.stringify(response));
                        unblockUI();
                    } else {
                        var token = response.id;

                        $('#hdnCreateTokenResponse').val(JSON.stringify(response));
                        $('#hdnToken').val(token);
                        $('#frmCharge').submit();
                    }
                }

                var month = $('#txtExpiryMonth'),
                    year = $('#txtExpiryYear'),
                    cvc = $('#txtCvc'),
                    cardHolder = $('#txtCardHolderName');


                cvc.mask('0000', {
                    onComplete: function () {
                        cardHolder.focus();
                    }
                });
                return;
            }

            $('#frmCharge').submit();
        };
        //Set Preferred in Dropdown
        $(function(){
            var first_data_select=$("#CreditId option:first").html();
            var IsPreferrd='@Model.PaymentModel.IsPreferrd';

            if (IsPreferrd == 'True') {
                $("#CreditId option:first").html(first_data_select + " (preferred)");
            }
        });
        if ($(':radio[name="PaymentMethod"]').attr('chk') == '1') {

            var radio="#"+$(':radio[name="PaymentMethod"]').attr('id');

            setconvfee(radio);
        }


    })

    $(".schedule").each(function () {
        var sectionHeight = $(this).outerHeight();
        var title = $(this).find(".season-name .title");
        if (title.outerWidth() > sectionHeight) {
            title.attr("title", title.text());
            while (title.outerWidth() > sectionHeight) {
                title.text(title.text().trim().substring(0, title.text().length - 1));
            }
            title.text(title.text().substring(0, title.text().length - 3) + "...");
        }
    });

    if (is.ie()) {
        $(".season-name").remove();
    }


    $("#submitzeropayment").click(function (e) {
        blockUI();
        e.preventDefault();

        var url = $(this).attr("data-action");

        window.location = url;

    });

    $("#applyCoupon").click(function () {
        //-----loading-----
        var couponCode = $("#coupnCode").val();
        if (couponCode == null || couponCode == '') {
            toastr.error("Please enter coupon code.");
            return;
        }
        blockUI();

        if (couponCode == null || couponCode == '')
            return;
        var url = $(this).attr("data-action");
        var userId = $(this).attr("data-userId");
        url += "?couponCode=" + encodeURIComponent(couponCode);

        if (userId != null && userId != "" && userId != "0")
            url += "&userId=" + userId;

        $.ajax({
            url: url,
            success: function (res) {
                if (res.Status) {
                    location.reload();
                } else {
                    toastr.error(res.Message);
                }
            },
            error: function (ex) {
                toastr.error("unexpected error");
            },
            complete: function () {
                unblockUI();
            }

        });
    });

    $("#addDonation").click(function () {
        //-----loading-----

        var donationAmount = $("#donationAmount").val();
        if (donationAmount == null || donationAmount == '') {
            toastr.error("Please enter the amount you would like to donate.");
            return;
        }
        blockUI();
        var url = $(this).attr("data-action");
        var userId = $(this).attr("data-userId");
        url += "?donationAmount=" + donationAmount;

        if (userId != null && userId != "" && userId != "0")
            url += "&userId=" + userId;

        $.ajax({
            url: url,
            success: function (res) {
                if (res.Status) {
                    location.reload();
                } else {
                    unblockUI();
                    toastr.error(res.Message);
                }
            },
            error: function (ex) {
                unblockUI();
                toastr.error("unexpected error");
            },
            complete: function () {

            }

        });
    });

    $("#OfflineOrderPayment_1").click(function () {

        document.getElementById('OfflinePayment').value = 'true';
    });
    $("#OfflineOrderPayment_0").click(function () {

        document.getElementById('OfflinePayment').value = 'false';
    });
    //***************************************************for send link of peyment method radio buttons start
    function refresh() {
        location.reload();
    }
    //***************************************************for send link of peyment method radio buttons end

    $("#pay-by-credit").click(function () {
        if ($("#pay-by-credit-input") && $("#pay-by-credit-input").is(':checked')) {
            var totaldecimal = Number.parseFloat(total.replace(/[^0-9\.]/g, ''));
            var creditdecimal = Number.parseFloat(credit.replace(/[^0-\9.]/g, ''));
            if (totaldecimal < creditdecimal) {
                maxamount = total;
                $(".pay-buttons-hideable").hide();
                $("#pay-by-credit-button").show();
            } else {
                maxamount = totaldecimal - creditdecimal;
                if (maxamount.toString().indexOf('.') !== -1) {
                    maxamount = "$" + maxamount;
                } else {
                    maxamount = "$" + maxamount + ".00";
                }
                $(".pay-buttons-hideable").show();
                $("#pay-by-credit-button").hide();
            }
            $("#total-price-span").html(maxamount);
        } else {
            $("#total-price-span").html(total);
            $(".pay-buttons-hideable").show();
            $("#pay-by-credit-button").hide();
        }
    });

    //**********************************peyment method radio buttons start*********************************************

    function InitRadio(name) {

        $.each($(':radio[name="' + name + '"]'), function () {

            $(".form-radio div input:first").attr('chk', '1');
            $(".form-radio div input:first").trigger("click");

            $(this).on("click", function (event) {

                var radio="#"+event.currentTarget.id
                setconvfee(radio);
                $(this).nextAll("label:first,div.container-boxcheck").find("span:not('.clear-block')").css("display", "block");

                SetRadioButtonChkProperty($(this).val(), name);
            });

        });

    }

    function SetRadioButtonChkProperty(val, name) {
        $.each($(':radio[name="' + name + '"]'), function () {
            if ($(this).val() != val)
                $(this).attr('chk', '0');
            else {

                if ($(this).attr('chk') == '0')

                    $(this).attr('chk', '1');
                if ($(this).attr('chk') == '1'){

                }
                else {
                    $(this).attr('chk', '0');
                    $(this).prop('checked', false);

                }
            }

        });


    }

    $(function () {
        $("input[type='radio']").change(function () {
            $("#send-url").attr("disabled", false);
            document.getElementById("send-url").style.backgroundColor="#e7830d";
        });
    });



    //********************************** peyment method radio buttons End *********************************************

    //********************************** Msg Show/Hide For Radio Buttons *********************************************
    function toggle_visibility(msgid) {

        $('#txtCardNumber').on('change', function(){
            $(this).val($(this).val().replace('-',""))
            $(this).val($(this).val().replace(' ',""))
            $(this).val($(this).val().trim())
        });

        $(".msg-checked").hide();
        $('#'+ msgid).show();

        var countInstallment = 0;
        var countCreditCards=@Model.CreditCards.Count;

        var setactive= $("#preferredpaymentmethod");

        @if(Model.Cart.Order.OrderInstallments != null && Model.Cart.Order.OrderInstallments.Any())
        {
            <text>
               countInstallment = @Model.Cart.Order.OrderInstallments.Count;
            </text>
        }

        var isAutoCharge = '@Model.Cart.Order.IsAutoCharge';

        @if(Model.PaymentModel.ActionCaller == JumbulaSubSystem.MakeaPayment)
        {
            var isAutoCharge = Model.IsAutoCharge;

            if(isAutoCharge)
            {
                <text>
                 isAutoCharge = 'True';
                </text>
            }
        }
        if (isAutoCharge =='True') {

            $("#lblpreferredpaymentmethod").css("display", "block")

            if (countCreditCards == 0 && setactive != null && ('@Model.PaymentModel.ActionCaller' == 'Order' || '@Model.PaymentModel.ActionCaller' == 'MakeaPayment' || '@Model.InvoiceId' != '') && '@Model.EnableCreditCardPayment' == 'True')
            {
                setactive.get(0).checked = true;
                $("#preferredpaymentmethod").prop("disabled","disabled");
                $("#lblpreferredpaymentmethod").css("display", "block")
            }

            if (countCreditCards >= 1 && setactive !=null  && ('@Model.PaymentModel.ActionCaller' == 'Order' || '@Model.PaymentModel.ActionCaller' == 'MakeaPayment' ||  '@Model.InvoiceId' != '') && '@Model.EnableCreditCardPayment'=='True') {
                var isPreferrd = '@Model.PaymentModel.IsPreferrd';

                if (isPreferrd == 'False') {

                    setactive.get(0).checked = true;
                    $("#preferredpaymentmethod").prop("disabled","disabled");
                    $("#lblpreferredpaymentmethod").css("display", "block")
                }
                else
                {
                    setactive.get(0).checked = false;
                }
            }

            if (isAutoCharge =='False') {

                $("#lblpreferredpaymentmethod").css("display", "none")
            }
        }
        else
        {
            $("#lblpreferredpaymentmethod").css("display", "none")
        }

    }


    if (is.safari()) {
        var safariInit = function () {
            $(".schedule-body").outerWidth($(".order-item-schedule .schedule").eq(0).outerWidth() - 36);
        };
        $(window).on("resize", safariInit);
        safariInit();
    }


    $(function(){
        if (@Model.Cart.PayableAmount == 0) {

        }
        else
        {
            if ($(':radio[name="' + name + '"]').length > 1 ) {

                $.each($(':radio[name="' + name + '"]'), function () {

                });
            }
            else{
                $(this).attr('chk', '0');
                $(this).prop('checked', 'checked');
            }
        }
    });
    blockUI();
    $(window).load(unblockUI);

    function setconvfee(event){

        if ('@Model.InvoiceId' =='') {

            if ('@Model.TotalWithoutConvenienceFee' !='') {

                if ($(event).val() == "Cash" || $(event).val() == "BankTransfer" || $(event).val() == "Scholarship" || $(event).val() == "FinancialAid" || $(event).val() == "Other" ) {

                    document.getElementById("send-url").innerHTML ="Place Order" + '(@Model.TotalWithoutConvenienceFee)';

                    @foreach (var item in Model.Cart.Order.RegularOrderItems)
                    {
                        var convienenceFee= item.OrderChargeDiscounts.Where(cd => (int)cd.Category > 0 && cd.Category == ChargeDiscountCategory.Convenience).Sum(c => c.Amount);

                        if (item.ProgramTypeCategory != ProgramTypeCategory.Subscription && item.ProgramTypeCategory != ProgramTypeCategory.BeforeAfterCare)
                        {
                            if (!Model.HideAllProgramsPrice)
                            {
                                if (Model.HiddenPricePrograms != null)
                                {
                                    if (!Model.HiddenPricePrograms.Any(p => p == item.ProgramSchedule.Program.Id))
                                    {
                              <text>
                              document.getElementById("tuition-price-"+@item.Id).innerHTML =  '@CurrencyHelper.FormatCurrencyWithPenny(@item.TotalAmount - @convienenceFee, Model.Cart.Currency)';
                             </text>
                                    }
                                }
                                else
                                {
 <text>
                              document.getElementById("tuition-price-"+@item.Id).innerHTML =  '@CurrencyHelper.FormatCurrencyWithPenny(@item.TotalAmount - @convienenceFee, Model.Cart.Currency)';
                             </text>
                                }
                            }

                        }

                    }
                        if (document.getElementById("orderAmount")) {
                            document.getElementById("orderAmount").innerHTML='@Model.TotalOrderAmountWithoutConvenienceFee';
                        }
                    $(".convienence-fee").hide();

                        if (document.getElementById("payableAmount")) {
                            document.getElementById("payableAmount").innerHTML='@Model.TotalWithoutConvenienceFee';
                        }
                    }
                else{

                    var countInstallment=0;
                    @if (Model.Cart.Order.OrderInstallments != null && Model.Cart.Order.OrderInstallments.Any())
                        {
                             <text>
                    countInstallment = @Model.Cart.Order.OrderInstallments.Count;
                    </text>
                        }
                    if (countInstallment>0) {

                        document.getElementById("send-url").innerHTML ="Place Order" +'( @CurrencyHelper.FormatCurrencyWithPenny(Model.Cart.PayableAmount, Model.Cart.Currency))';

                    }
                    else{   document.getElementById("send-url").innerHTML ="Place Order" +'(@CurrencyHelper.FormatCurrencyWithPenny(Model.Cart.Order.RegularOrderItems.Sum(o => o.TotalAmount), Model.Cart.Currency))';
                    }

                    @foreach (var item in Model.Cart.Order.RegularOrderItems)
                    {
                        if (!Model.HideAllProgramsPrice)
                        {
                            if (Model.HiddenPricePrograms != null)
                            {
                                if (!Model.HiddenPricePrograms.Any(p => p == item.ProgramSchedule.Program.Id))
                                {
                <text>

                    if ('@item.ProgramScheduleId.HasValue'=='True' && '@item.ProgramTypeCategory' != 'Subscription' &&  '@item.ProgramTypeCategory' != 'BeforeAfterCare' ) {
                        document.getElementById("tuition-price-"+@item.Id).innerHTML =  '@CurrencyHelper.FormatCurrencyWithPenny(item.TotalAmount, Model.Cart.Currency)';

                    }
                    if (document.getElementById("orderAmount")) {
                        document.getElementById("orderAmount").innerHTML='@CurrencyHelper.FormatCurrencyWithPenny(Model.Cart.Order.RegularOrderItems.Sum(o => o.TotalAmount), Model.Cart.Currency)';
                    }
                    </text>
                                }
                            }
                            else
                            {
<text>

                    if ('@item.ProgramScheduleId.HasValue'=='True' && '@item.ProgramTypeCategory' != 'Subscription' &&  '@item.ProgramTypeCategory' != 'BeforeAfterCare' ) {
                        document.getElementById("tuition-price-"+@item.Id).innerHTML =  '@CurrencyHelper.FormatCurrencyWithPenny(item.TotalAmount, Model.Cart.Currency)';

                    }
                    if (document.getElementById("orderAmount")) {
                        document.getElementById("orderAmount").innerHTML='@CurrencyHelper.FormatCurrencyWithPenny(Model.Cart.Order.RegularOrderItems.Sum(o => o.TotalAmount), Model.Cart.Currency)';
                    }
                    </text>
                            }
                        }
                    }
                    $(".convienence-fee").show();

                        if (document.getElementById("payableAmount")) {
                            document.getElementById("payableAmount").innerHTML='@CurrencyHelper.FormatCurrencyWithPenny(Model.Cart.PayableAmount, Model.Cart.Currency)';
                        }

                    }
            }
            else{
                $(".totalWithoutConvenienceFee").hide();
            }
        }
    }

    var AlarmInTestMode = {
        message: "You are placing a TEST order only, not an actual live registration. Contact your organization administrator immediately If you trying to place a real registration.",
        title: 'Warning',
        size: eModal.size.xl,
        subtitle: 'smaller text header',
        label: "Ok"   // use the positive label as key

    };



</script>